VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "DF TTS SDK for Windows VB6 Sample"
   ClientHeight    =   4515
   ClientLeft      =   60
   ClientTop       =   360
   ClientWidth     =   6150
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   4515
   ScaleWidth      =   6150
   StartUpPosition =   2  'CenterScreen
   Begin VB.ComboBox Combo1 
      Height          =   315
      ItemData        =   "Form1.frx":0000
      Left            =   960
      List            =   "Form1.frx":0002
      Style           =   2  'Dropdown List
      TabIndex        =   7
      Top             =   240
      Width           =   4935
   End
   Begin VB.CommandButton Command4 
      Caption         =   "Pause/Resume"
      Height          =   375
      Left            =   1680
      TabIndex        =   4
      Top             =   3480
      Width           =   1335
   End
   Begin VB.CommandButton Command3 
      Caption         =   "Stop"
      Height          =   375
      Left            =   3120
      TabIndex        =   3
      Top             =   3480
      Width           =   1335
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Export"
      Height          =   375
      Left            =   4560
      TabIndex        =   2
      Top             =   3480
      Width           =   1335
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Speak"
      Height          =   375
      Left            =   240
      TabIndex        =   1
      Top             =   3480
      Width           =   1335
   End
   Begin VB.TextBox Text1 
      Height          =   2535
      Left            =   240
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Text            =   "Form1.frx":0004
      Top             =   720
      Width           =   5655
   End
   Begin VB.Label Label2 
      Caption         =   "Voice: "
      Height          =   255
      Left            =   240
      TabIndex        =   6
      Top             =   240
      Width           =   615
   End
   Begin VB.Label Label1 
      Height          =   255
      Left            =   240
      TabIndex        =   5
      Top             =   4080
      Width           =   5655
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'///****************************************************************************
'//// Name:        DFTTSSampleVB6 with DFTTS Desktop SDK v 3.5.0
'//// Purpose:
'//// Author:      Digital Future
'//// Modified by:
'//// Created:     06/10/2008, updated 7/19/2008
'//// RCS-ID:
'//// Copyright:   (C) Digital Future 2007-2008. All rights reserved.
'//// Licence:     see license document
'//***************************************************************************/

'///****************************************************************************
'////                   W A R N I N G!!!
'////
'////
'////      DO NOT RUN THIS SAMPLE FROM THE VB IDE! YOU WILL GET AN ERROR (IDE DOES NOT SUPPORT SDK DLL LOADING)
'////
'////      RUN THE EXECUTABLE DIRECTLY!
'////
'////
'//***************************************************************************/

Option Explicit


Private bIsPaused As Boolean

'We use some colletions here to hold the installed voices infos. _
This part is a fast example on how to retrieve the installed voices. _
It focuses on the API call rather than the actual display and data saving. _
There should be a more elegant way to do this.

                
Private cDataVoiceNames As Collection
                
Private cDataVoiceEngines As Collection
                
Private cDataVoiceLangs As Collection
                
Private cDataVoiceIds As Collection
              
Private Sub Form_Load()

    bIsSpeaking = False
    
    'Hook Windows messages to be able to track OnWord and OnExportFinished events (see documentation)
    Hook
    
    '(!YOU NEED TO CHANGE THE PATHS TO MATCH YOUR PATHS!)"

    Dim szNeospDBPaths(NEOSPEECH_NUM_VOICES - 1) As String
    
    bIsPaused = False
    
    szNeospDBPaths(0) = vbNullString 'Kate
    szNeospDBPaths(1) = "C:\Program Files\VW\VT\Paul\M16" 'Paul
    szNeospDBPaths(2) = vbNullString 'Miyu
    szNeospDBPaths(3) = vbNullString 'Show
    szNeospDBPaths(4) = vbNullString 'Misaki
    szNeospDBPaths(5) = vbNullString 'Lily
    szNeospDBPaths(6) = vbNullString 'Wang
    szNeospDBPaths(7) = vbNullString 'Junwoo
    szNeospDBPaths(8) = vbNullString 'Sujin
    szNeospDBPaths(9) = vbNullString 'Yumi
    szNeospDBPaths(10) = vbNullString 'Gyuri
    szNeospDBPaths(11) = vbNullString 'Dayoung
    
  

    Dim szNeospLicPaths(NEOSPEECH_NUM_VOICES - 1) As String
    
    
    szNeospLicPaths(0) = vbNullString 'Kate
    szNeospLicPaths(1) = "C:\Program Files\VW\VT\Paul\M16\data-common\verify\verification.txt" 'Paul
    szNeospLicPaths(2) = vbNullString 'Miyu
    szNeospLicPaths(3) = vbNullString 'Show
    szNeospLicPaths(4) = vbNullString 'Misaki
    szNeospLicPaths(5) = vbNullString 'Lily
    szNeospLicPaths(6) = vbNullString 'Wang
    szNeospLicPaths(7) = vbNullString 'Junwoo
    szNeospLicPaths(8) = vbNullString 'Sujin
    szNeospLicPaths(9) = vbNullString 'Yumi
    szNeospLicPaths(10) = vbNullString 'Gyuri
    szNeospLicPaths(11) = vbNullString 'Dayoung
    
    Dim iLoadedEngines(0 To NUM_ENGINE_INITIALIZATIONS - 1) As Long
    Dim iLoadedEnginesReturnValues(0 To NUM_ENGINE_INITIALIZATIONS - 1) As Long
    
   Call InitDFTTSEngineEx3(Me.hwnd, _
                    szNeospDBPaths(0), _
                    szNeospDBPaths(1), _
                    szNeospDBPaths(2), _
                    szNeospDBPaths(3), _
                    szNeospDBPaths(4), _
                    szNeospDBPaths(5), _
                    szNeospDBPaths(6), _
                    szNeospDBPaths(7), _
                    szNeospDBPaths(8), _
                    szNeospDBPaths(9), _
                    szNeospDBPaths(10), _
                    szNeospDBPaths(11), _
                    szNeospLicPaths(0), _
                    szNeospLicPaths(1), _
                    szNeospLicPaths(2), _
                    szNeospLicPaths(3), _
                    szNeospLicPaths(4), _
                    szNeospLicPaths(5), _
                    szNeospLicPaths(6), _
                    szNeospLicPaths(7), _
                    szNeospLicPaths(8), szNeospLicPaths(9), szNeospLicPaths(10), szNeospLicPaths(11), iLoadedEngines(0), iLoadedEnginesReturnValues(0))
                    
            
            'Catch load errors

            Dim sEngineName As String
            sEngineName = ""
            
            Dim result As InitDFTTSEngineReturnValue

            Dim sNeospVoiceNames(0 To NEOSPEECH_NUM_VOICES - 1) As String
            
            sNeospVoiceNames(0) = NEOSPEECH_KATE_ENG_NAMESTR
            sNeospVoiceNames(1) = NEOSPEECH_PAUL_ENG_NAMESTR
            sNeospVoiceNames(2) = NEOSPEECH_MIYU_JPN_NAMESTR
            sNeospVoiceNames(3) = NEOSPEECH_SHOW_JPN_NAMESTR
            sNeospVoiceNames(4) = NEOSPEECH_MISAKI_JPN_NAMESTR
            sNeospVoiceNames(5) = NEOSPEECH_LILY_CHI_NAMESTR
            sNeospVoiceNames(6) = NEOSPEECH_WANG_CHI_NAMESTR
            sNeospVoiceNames(7) = NEOSPEECH_JUNWOO_KOR_NAMESTR
            sNeospVoiceNames(8) = NEOSPEECH_SUJIN_KOR_NAMESTR
            sNeospVoiceNames(9) = NEOSPEECH_YUMI_KOR_NAMESTR
            sNeospVoiceNames(10) = NEOSPEECH_GYURI_KOR_NAMESTR
            sNeospVoiceNames(11) = NEOSPEECH_DAYOUNG_KOR_NAMESTR
            
            Dim intI As Integer

            For intI = 0 To NUM_ENGINE_INITIALIZATIONS - 1
            
              

                If iLoadedEngines(intI) = NEOSPEECHVOICETEXT Then
                

                    sEngineName = "NEOPSEECHVOICETEXT Engine Load Result for voice " & _
                        sNeospVoiceNames(intI) & ": "

                
                ElseIf iLoadedEngines(intI) = CEPSTRAL Then
                

                    sEngineName = "CEPSTRAL Engine Load Result: "

                
                ElseIf iLoadedEngines(intI) = ATTNV Then
                

                    sEngineName = "ATTNV (INTERNAL USE ONLY, USE MSSAPI) Engine Load Result: "
                    
                End If

                result = iLoadedEnginesReturnValues(intI)

                Debug.Print sEngineName & result & vbNewLine
            
                'MsgBox sEngineName & result & vbNewLine
                
            Next
            
            'This is how to list all installed supported voices
            'We assign our collections here


            Dim szVoiceName As String
            szVoiceName = "*******************************************************************"

            Dim iVoiceNameLen As Integer
            iVoiceNameLen = 0

            Dim vet As Integer
            vet = 0

            Dim lang As Integer
            lang = 0

            Dim iVoiceID As Integer
            iVoiceID = 0

            Dim bSetDefault As Boolean
            bSetDefault = False

            Dim z As Integer
            z = 0
                
            Dim iUsedNumOfVoices As Integer
            iUsedNumOfVoices = 0
            
            Set cDataVoiceNames = New Collection
               
                
            Set cDataVoiceEngines = New Collection
                
                               
            Set cDataVoiceLangs = New Collection
                
                
            Set cDataVoiceIds = New Collection
                
              
            Do While 0 = 0
                    
                    Dim viresult As DFTTSVoiceInfoReturnValue
                    
                    viresult = GetDFTTSVoice( _
                        z, vet, szVoiceName, iVoiceNameLen, _
                        iVoiceID, lang)
                        
                    'DO NOT USE MSSAPI NATIVELY FROM VB! IT WILL CRASH THE APP!!!
                    If viresult = GET_DFTTS_VI_SUCCESS And vet <> MSSAPI Then
                    
                        iUsedNumOfVoices = iUsedNumOfVoices + 1
                        
                        cDataVoiceNames.Add Left$(szVoiceName, iVoiceNameLen)
                        
                        cDataVoiceEngines.Add vet
                        
                        cDataVoiceLangs.Add lang
                        
                        cDataVoiceIds.Add iVoiceID
                        
                        
                    Else
                        
                        Exit Do
                        
                    End If

                    z = z + 1
                    
            Loop
                
                
            Dim it As Variant
                
            For Each it In cDataVoiceNames
                    
                Combo1.AddItem CStr(it)
                    
            Next
                
             
            Combo1.ListIndex = 0
                
                
            If iUsedNumOfVoices = 0 Then
                MsgBox "No voices can be found on your system! Please download and install at least 1 voice!"
            End If
            
            Dim dictreturn As LoadDFTTSUserDictReturnValue
            
            'User Dictionary Loading: _
            (read dictionary documentation per engine located in folder DictionarySystems)
            
            'This is how to load a dictionary for the NeoSpeech provider (the dictionary is loaded _
            by language from a file (see file in exe directory) (the dict name, voice name, _
            dict content do NOT matter), the dictionary number matters)
            
            'MakeLanguage(LANG_ENGLISH, SUBLANG_ENGLISH_US) = 1033 - You can just use 1033
        
            'dictreturn = LoadDFTTSUserDict(1, vbNullString, _
                 "neospeech_userdict_eng.csv", _
                 NEOSPEECHVOICETEXT, MakeLanguage(LANG_ENGLISH, SUBLANG_ENGLISH_US), _
                 vbNullString, vbNullString)
                 
            'This is how to load a dictionary for the Cepstral provider (the dictionary is loaded
            'by voice from a file (see file in exe directory);
            'The dictionary number, dict name, dict content do NOT matter.)
            
            'dictreturn = LoadDFTTSUserDict(-1, vbNullString, _
                 "cepstral_dictionary.txt", _
                 CEPSTRAL, LANG_SUBLANG_NEUTRAL, "David", vbNullString)
                 
            If dictreturn <> LOAD_USER_DICT_SUCCESS Then
                MsgBox "SDK Load Dictionary failed with error: " & dictreturn, vbCritical, "Error"
            End If
                     
    
End Sub

Private Sub Command1_Click()

    Dim result As DFTTSSpeakReturnValue
    
    Dim currentCIndex As Integer
        
    currentCIndex = Combo1.ListIndex + 1
    
           
    result = DFTTSSpeak(Me.hwnd, _
        cDataVoiceEngines.Item(currentCIndex), cDataVoiceNames.Item(currentCIndex), _
        cDataVoiceIds.Item(currentCIndex), _
        cDataVoiceLangs.Item(currentCIndex), Text1.Text, -1, _
        -1, -1, -1, _
        1, DFTTS_TEXT_TYPE_XML, -1)
        
        
   
    If result <> DFTTS_SPEAK_SUCCESS Then
        MsgBox "SDK Speak failed with error: " & result, vbCritical, "Error"
    Else
        bIsSpeaking = True
    End If
        
End Sub


Public Sub Hook()
     
   gHW = Me.hwnd
    
   lpPrevWndProc = SetWindowLong(gHW, GWL_WNDPROC, _
                                 AddressOf WindowProc)
      
End Sub

Public Sub Unhook()

   'Reset the message handler for this window
   If gHW = 0 Then Exit Sub
   
   Call SetWindowLong(gHW, GWL_WNDPROC, lpPrevWndProc)
   gHW = 0
   
End Sub

Private Sub Command2_Click()

    Dim currentCIndex As Integer
        
    currentCIndex = Combo1.ListIndex + 1
                     
         
    Dim result As DFTTSExportReturnValue
    
    Dim format As Integer
    format = 0
        
    If cDataVoiceEngines.Item(currentCIndex) = NEOSPEECHVOICETEXT Then
        format = VT_FILE_API_FMT_ALAW_WAVE
    End If
    
    ' Example for NeoSpeech Paul
    result = DFTTSExportToFileEx(cDataVoiceEngines.Item(currentCIndex), _
        cDataVoiceNames.Item(currentCIndex), cDataVoiceIds.Item(currentCIndex), _
        cDataVoiceLangs.Item(currentCIndex), Text1.Text, -1, _
        -1, -1, -1, _
        -1, DFTTS_TEXT_TYPE_XML, _
        sFileName, format, _
        "pcm16", 16000, _
        2)
        
          
    If result <> DFTTS_EXPORT_SUCCESS Then
        MsgBox "SDK Export failed with error: " & result, vbCritical, "Error"
    End If
                                      
End Sub

Private Sub Command3_Click()

    Dim currentCIndex As Integer
        
    currentCIndex = Combo1.ListIndex + 1
    
    Dim result As DFTTSStopReturnValue
    
    result = DFTTSStop(cDataVoiceEngines.Item(currentCIndex), cDataVoiceLangs.Item(currentCIndex))
    
    If result <> DFTTS_STOP_SUCCESS Then
        MsgBox "SDK Stop failed with error: " & result, vbCritical, "Error"
        
    Else
    
        bIsSpeaking = False
        
    End If
    
End Sub

Private Sub Command4_Click()

    Dim currentCIndex As Integer
        
    currentCIndex = Combo1.ListIndex + 1

    If bIsPaused Then
    
        bIsPaused = False
        
        Dim result1 As DFTTSResumeReturnValue
    
        result1 = DFTTSResume(cDataVoiceEngines.Item(currentCIndex), _
                                cDataVoiceLangs.Item(currentCIndex))
        
        If result1 <> DFTTS_RESUME_SUCCESS Then
            MsgBox "SDK Resume failed with error: " & result1, vbCritical, "Error"
        End If
    
    ElseIf bIsPaused = False Then
    
        bIsPaused = True
        
        Dim result2 As DFTTSPauseReturnValue
    
        result2 = DFTTSPause(cDataVoiceEngines.Item(currentCIndex), _
                                cDataVoiceLangs.Item(currentCIndex))
        
        If result2 <> DFTTS_PAUSE_SUCCESS Then
            MsgBox "SDK Pause failed with error: " & result2, vbCritical, "Error"
        End If
    
    End If
    
End Sub




Private Sub Form_Unload(Cancel As Integer)

    
    If bIsSpeaking Then
    
        Dim currentCIndex As Integer
            
        currentCIndex = Combo1.ListIndex + 1
        
        Dim res As DFTTSStopReturnValue
        
        res = DFTTSStop(cDataVoiceEngines.Item(currentCIndex), cDataVoiceLangs.Item(currentCIndex))
        
        If res <> DFTTS_STOP_SUCCESS Then
            MsgBox "SDK Stop failed with error: " & res, vbCritical, "Error"
        End If
    
    End If

    Dim result As UninitDFTTSEngineReturnValue
    
    Unhook
    
    result = UninitDFTTSEngine
    
    If result <> UNINIT_DFTTS_ENGINE_SUCCESS Then
        MsgBox "SDK uninitialization failed.", vbCritical, "Error"
    End If
    
    Set cDataVoiceNames = Nothing
                                
    Set cDataVoiceEngines = Nothing
                
    Set cDataVoiceLangs = Nothing
    
    Set cDataVoiceIds = Nothing
    
End Sub
